﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace MVCPresentation.Models
{
    public class Repository<T> : IRepository<T>
    {
        protected HttpContext _ctx;
        protected List<T> _list;

        public Repository()
        {
            _ctx = HttpContext.Current;
            _list = SavedList;
        }

        public IEnumerable<T> GetAll()
        {
            return SavedList;
        }

        public void Add(T item)
        {
            _list.Add(item);
        }

        public void Delete(T item)
        {
            _list.Remove(item);
        }
       
        protected List<T> SavedList
        {
            get
            {
                if (_ctx.Session["AtomList"] == null)
                {
                    _ctx.Session["AtomList"] = new List<T>();
                }
                _list = (List<T>)_ctx.Session["AtomList"];
                return _list;
            }
        }

        public void Save()
        {
            _ctx.Session["AtomList"] = _list;
        }
    }
}